/*
   XBN Java:  Generically useful, non-GUI Java code.
   http://sourceforge.net/projects/xbnjava

   Copyright (C) 1997-2003, Jeff Epstein
   All rights reserved.

   Modifications: No

   Redistribution in binary form, with or without modifications, are permitted provided that the following conditions are met:

      * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
      * If modifications are made to source code then this license should indicate that fact in the "Modifications" section above.
      * Neither the author, nor the contributors may be used to endorse or promote products derived from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

   [NOTE:  This license contains NO advertising clause.]
 */
package xbn_junit.array;
   import xbn.util.XBNTestCase;
      import xbn.array.UtilArray;

      import junit.framework.Test;
      import junit.framework.TestSuite;
      import junit.textui.TestRunner;


public class JUTUtilArray extends XBNTestCase  {
   private UtilArray uArray = new UtilArray();

   public JUTUtilArray(String s_name) {
      super(s_name);
   }


   public void test_getMiddleIdx() {
      //Bad bounds, which may mean they finished their search
      gmi_assert(-1, -1, 13, 4);

      //Zero total elements (same array index)
      gmi_assert(13, 13, 13, 13);

      //One element, beyond the left index
      gmi_assert(4, 5, 4, 5);

      //Two elements, beyond the left index
      gmi_assert(5, 5, 4, 6);
   }

   public void gmi_assert(int i_assertRoundDown, int i_assertRoundUp, int i_idxLeft, int i_idxRight)  {
      xassertTrue(i_assertRoundDown == uArray.getMiddleIdx(i_idxLeft, i_idxRight));
      xassertTrue(i_assertRoundDown == uArray.getMiddleIdx(i_idxLeft, i_idxRight, true));
      xassertTrue(i_assertRoundUp == uArray.getMiddleIdx(i_idxLeft, i_idxRight, false));
   }

   public void setUp() throws Exception  {
      super.setUp();
   }

   public void tearDown() throws Exception  {
      super.tearDown();
   }

   public static Test suite() {
      TestSuite ts = new TestSuite(JUTUtilArray.class);
      return ts;
   }

   public static void main(String[] as_cmdLineParams) {
      TestRunner.run(suite());
      printSummary();
   }
}
